/*****************************************************************
  CNeoWindow.h

  Header file for the CNeoWindow class.
*****************************************************************/

#ifndef __CNeoWindow__
#define __CNeoWindow__

#include <Timer.h>
#include "LWindow.h"
#include "LPeriodical.h"
#include "LListener.h"
#include "NeoBench.h"

class CNeoFilePP;
class CRawText;
class LEditField;
class LButton;
class CNeoWindow;
class CNeoIndexIterator;

#define kTitlePICTID	129

class CNeoWindow : public LWindow, public LPeriodical, public LListener {
public:
						CNeoWindow(const ResIDT aResID, CNeoDocPP *aDocument);

						/** Drawing **/
	void				DrawSelf(void);

						/** Statistics **/
	void				checkFileState(void);
	void				ClearStatPanes(void);
	short				getPhase(void) const;
	long				getPhaseTarget(const short aPhase) const;
	Boolean				getState(void) const;
	void				getTargetTotals(void);
	long				GetTotalNum(short index);
	void				setDocument(CNeoDocPP *aDoc);
	void				setPhase(const short aPhase);
	void				setState(const Boolean aState);
	void				UpdateCol(short aPhase, short aRow, long aValue);

						/** Events/Drawing **/
	virtual void		ClickInZoom(const EventRecord& inMacEvent, short inZoomDirection);
	virtual void		doSomeWork(const short aPhase, TMTask *aTimer);
	virtual Boolean		HandleKeyPress(const EventRecord &inKeyEvent);
	virtual void		ListenToMessage(MessageT aMessage, void *aParam);
	virtual void		SpendTime(const EventRecord &inMacEvent);

protected:
	NeoPhase			fPhaseInfo[kMaxPhase +1];	// The main phases
	Boolean				fState;						// Running state
	short				fPhase;						// The current phase
	CNeoIndexIterator *	fIterator;					// For traversing index of objects
	CNeoPersist *		fObject;					// Object pointer for serially finding objects
	long				col_value[3];				// 3 columns - soFar, PerRecord, Total
	short				col_index;					// Index into the column

	CRawText *			NeoRawTexts[kMaxPhase +1][kMaxCol +1];	// the texts displaying the numbers
	LEditField *		NeoEditTexts[kMaxPhase +1];				// the TOTALS editable texts
	CRawText *			NeoPhaseNames[kMaxPhase +1];			// Phase names
	LButton *			NeoStopButton;							// Stop button
	LButton *			NeoGoButton;							// Go button
	CRawText *			fSizeStatic;							// Object size label
	LEditField *		fSizeText;								// Object size text

	long				maxValue[kMaxPhase +1];
	long				minValue[kMaxPhase +1];
};
#endif