/****
 * CNeoDoc.h
 *
 *	Document class for a NeoAccess-based application.
 *  Copyright  1992-1994 NeoLogic Systems.  All rights reserved.
 *
 ****/
#pragma once			/* Include this file only once */
#ifndef __CNeoDoc__
#define __CNeoDoc__ 1

#include "NeoTypes.h"
#ifdef CNeoDocBaseH
#include CNeoDocBaseH
#endif

class CNeoDatabase;

class CNeoDoc : public CNeoDocBase
{
public:
						// Instance Methods
						CNeoDoc(void);
	virtual				~CNeoDoc(void);
	static CNeoDoc *	FindByID(const NeoID aID);
	static CNeoDoc *	FindByIndex(const long aIndex);
	static CNeoDoc *	FindByName(const CNeoString &aName);
	virtual CNeoDatabaseNative *
						getDatabase(void) const = 0;
	virtual Boolean		isDirty(void) const = 0;
	static Boolean		PurgeCache(NeoSize aNeeded);
	static void			ResetDocListHead(void);
	virtual void		setDatabase(CNeoDatabaseNative *aDatabase) = 0;
	virtual void		setDirty(const Boolean aState = TRUE) = 0;

public:
	NeoID				fID;
	CNeoDoc *			fNext;

	static short		FCount;
	static CNeoDoc *	FDocumentList;
};
#endif
