/*****
 * CNeoAppPP.h
 *
 *	Application class for a PowerPlant -based application.
 *  Copyright  1992-1993 NeoLogic Systems.  All rights reserved.
 *
 *****/
#pragma once			/* Include this file only once */

#include "NeoTypes.h"
#include CNeoAppH
#include "LBroadcaster.h"

class CNeoDoc;
class LList;

//---------------------- PowerPlant Application ---------------------------------
class CNeoAppPP : public CNeoApp, public LBroadcaster {
public:
						CNeoAppPP(const OSType aSignature, const OSType aType);

						/** Window Methods **/
	static void			HideWindow(CNeoWindowBase *aWindow);
	static void			MoveWindow(CNeoWindowBase *aWindow, const Rect *aBounds, const Boolean aRedraw);
	static void			ShowWindow(CNeoWindowBase *aWindow, const Boolean aUpdateState, const Boolean aRedraw);

						/** Chore Methods **/
	virtual void		addChore(CNeoChore *aChore);
	virtual void		doChores(void);
	virtual void		removeChore(CNeoChore *aChore);
	virtual void		UseIdleTime(const EventRecord &aEvent);

						/** Document Management Methods **/
	virtual CNeoDoc	*	createDocument(void) = 0;

						/** PowerPlant-specific Methods **/
	virtual void		ChooseDocument(void);
	virtual LModelObject *
						MakeNewDocument(void);
	virtual void		OpenDocument(FSSpec *aSpec);
	virtual void		StartUp(void);

protected:
	LList *				fChores;
	CNeoDocPP *			fDocument;

public:
	static CNeoAppPP *	FApplication;
	static OSType		FFileType;
};
